> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Migrate a dataset to a data model (Beta)

POST https://api.sigmacomputing.com/v2/datasets/{datasetId}/migrate
Content-Type: application/json

Migrate a dataset (deprecated) to a data model. The response always includes the dataset's link details and its link and reference counts. For more information on how datasets are migrated to data models, see [Migrate a dataset to a data model](https://help.sigmacomputing.com/docs/migrate-a-dataset-to-a-data-model).

**Beta**: This documentation describes a public beta feature and is subject to the [Beta features](/docs/sigma-product-releases#beta-features) disclaimer.

### Usage notes
- Retrieve the **datasetId** by calling the [/v2/datasets](https://help.sigmacomputing.com/reference/list-datasets) endpoint.
- To skip the migration and return only the dataset's link details and its link and reference counts, pass `dryRun: true`.

### Usage scenarios
- **Plan dataset migration**: Pass `dryRun: true` to review the datasets and connection tables linked to the dataset, and how many documents reference it, before you migrate.
- **Migrate datasets in bulk**: If you want to migrate several datasets, you can use this endpoint to programmatically migrate the datasets returned by [/v2/datasets](https://help.sigmacomputing.com/reference/list-datasets) with a `migrationStatus` of `not-migrated`.


Reference: https://help.sigmacomputing.com/reference/migrate-dataset-to-data-model

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/datasets/{datasetId}/migrate:
    post:
      operationId: migrateDatasetToDataModel
      summary: Migrate a dataset to a data model (Beta)
      description: >
        Migrate a dataset (deprecated) to a data model. The response always
        includes the dataset's link details and its link and reference counts.
        For more information on how datasets are migrated to data models, see
        [Migrate a dataset to a data
        model](https://help.sigmacomputing.com/docs/migrate-a-dataset-to-a-data-model).


        **Beta**: This documentation describes a public beta feature and is
        subject to the [Beta
        features](/docs/sigma-product-releases#beta-features) disclaimer.


        ### Usage notes

        - Retrieve the **datasetId** by calling the
        [/v2/datasets](https://help.sigmacomputing.com/reference/list-datasets)
        endpoint.

        - To skip the migration and return only the dataset's link details and
        its link and reference counts, pass `dryRun: true`.


        ### Usage scenarios

        - **Plan dataset migration**: Pass `dryRun: true` to review the datasets
        and connection tables linked to the dataset, and how many documents
        reference it, before you migrate.

        - **Migrate datasets in bulk**: If you want to migrate several datasets,
        you can use this endpoint to programmatically migrate the datasets
        returned by
        [/v2/datasets](https://help.sigmacomputing.com/reference/list-datasets)
        with a `migrationStatus` of `not-migrated`.
      tags:
        - Datasets
      parameters:
        - name: datasetId
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/datasets_migrateDatasetToDataModel_Response_200
      requestBody:
        description: The request body.
        content:
          application/json:
            schema:
              type: object
              properties:
                shouldUpdateReferences:
                  type: boolean
                  description: >-
                    Whether to update references in workbooks that use this
                    dataset to point to the new data model.
                destFolderId:
                  type: string
                  description: >-
                    Optional destination folder ID where the data model should
                    be created. If not provided, the data model will be created
                    in the same folder as the dataset.
                dryRun:
                  type: boolean
                  description: >-
                    If true, do not perform the migration. Only return the link
                    details and the link and reference counts. Defaults to
                    false.
              required:
                - shouldUpdateReferences
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsSourceOneOf0Type:
      type: string
      enum:
        - dataset
      title: >-
        V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsSourceOneOf0Type
    V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsSource0:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsSourceOneOf0Type
        datasetId:
          type: string
          description: ID of the dataset.
      required:
        - type
        - datasetId
      description: A linked dataset.
      title: >-
        V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsSource0
    V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsSourceOneOf1Type:
      type: string
      enum:
        - table
      title: >-
        V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsSourceOneOf1Type
    V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsSource1:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsSourceOneOf1Type
        tableId:
          type: string
          description: ID of the connection table.
      required:
        - type
        - tableId
      description: A linked connection table.
      title: >-
        V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsSource1
    V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsSource:
      oneOf:
        - $ref: >-
            #/components/schemas/V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsSource0
        - $ref: >-
            #/components/schemas/V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsSource1
      description: The dataset or table that is the source of the link.
      title: >-
        V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsSource
    V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsTargetOneOf0Type:
      type: string
      enum:
        - dataset
      title: >-
        V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsTargetOneOf0Type
    V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsTarget0:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsTargetOneOf0Type
        datasetId:
          type: string
          description: ID of the dataset.
      required:
        - type
        - datasetId
      description: A linked dataset.
      title: >-
        V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsTarget0
    V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsTargetOneOf1Type:
      type: string
      enum:
        - table
      title: >-
        V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsTargetOneOf1Type
    V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsTarget1:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsTargetOneOf1Type
        tableId:
          type: string
          description: ID of the connection table.
      required:
        - type
        - tableId
      description: A linked connection table.
      title: >-
        V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsTarget1
    V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsTarget:
      oneOf:
        - $ref: >-
            #/components/schemas/V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsTarget0
        - $ref: >-
            #/components/schemas/V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsTarget1
      description: The dataset or table the link targets.
      title: >-
        V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsTarget
    V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItems:
      type: object
      properties:
        source:
          $ref: >-
            #/components/schemas/V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsSource
          description: The dataset or table that is the source of the link.
        target:
          $ref: >-
            #/components/schemas/V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItemsTarget
          description: The dataset or table the link targets.
      required:
        - source
        - target
      title: >-
        V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItems
    datasets_migrateDatasetToDataModel_Response_200:
      type: object
      properties:
        dataModelId:
          type:
            - string
            - 'null'
          description: ID of the newly-created data model. Null when `dryRun` is true.
        links:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2DatasetsDatasetIdMigratePostResponsesContentApplicationJsonSchemaLinksItems
          description: >-
            All datasets or connection tables linked to this dataset. Each can
            be a source, target, or part of a series of links.
        linkCount:
          type: number
          format: double
          description: Number of links the dataset has to other datasets.
        referenceCount:
          type: number
          format: double
          description: Number of references from other datasets to this dataset.
      required:
        - dataModelId
        - links
        - linkCount
        - referenceCount
      title: datasets_migrateDatasetToDataModel_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples



**Request**

```json
{
  "shouldUpdateReferences": true
}
```

**Response**

```json
{
  "dataModelId": "string",
  "links": [
    {
      "source": {
        "datasetId": "string",
        "type": "dataset"
      },
      "target": {
        "datasetId": "string",
        "type": "dataset"
      }
    }
  ],
  "linkCount": 1.1,
  "referenceCount": 1.1
}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/datasets/datasetId/migrate"

payload = { "shouldUpdateReferences": True }
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/datasets/datasetId/migrate';
const options = {
  method: 'POST',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{"shouldUpdateReferences":true}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/datasets/datasetId/migrate"

	payload := strings.NewReader("{\n  \"shouldUpdateReferences\": true\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/datasets/datasetId/migrate")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"shouldUpdateReferences\": true\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sigmacomputing.com/v2/datasets/datasetId/migrate")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{\n  \"shouldUpdateReferences\": true\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sigmacomputing.com/v2/datasets/datasetId/migrate', [
  'body' => '{
  "shouldUpdateReferences": true
}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/datasets/datasetId/migrate");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"shouldUpdateReferences\": true\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = ["shouldUpdateReferences": true] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/datasets/datasetId/migrate")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```